*!*	Description:
*!*	 You can use this class for managing value of property LockScreen.

*!*	Using:
*!*  The class has only two method. Push() and Pop()
*!*  Method Push() register form or toolbar and set LockScreen=.T. Next calling increase internal counter.
*!*  Method Pop() decrease internal counter. 
*!*	  If is zero, then will set LockScreen to value which was at first calling method Push()


#IF .F.
*!*	Example
PRIVATE loForm
loo=CREATEOBJECT("_LockScreenStack")
loo.Push(_Screen)
loo.Push(_Screen)

loForm=CREATEOBJECT("FORM")
loo.Push(loForm)

loo.Pop(_Screen)
loo.Pop(_Screen)

loo.Pop(loForm)
#ENDIF

#DEFINE _LSS_NotRegistered "A form was not register."

DEFINE CLASS _LockScreenStack AS Custom
   Name="_LockScreenStack"
   DIMENSION aKeys(2)
   iCount=0
   aKeys(1)=" "

   PROCEDURE Push(loForm)
      LOCAL lii
      IF NOT PEMSTATUS(loForm,"LockScreenIndex",5)
         loForm.AddProperty("LockScreenIndex",0)
         lii=0
      ELSE
         lii=loForm.LockScreenIndex
      ENDIF
      IF lii=0
         #IF VAL(SUBSTR(VERSION(),15,2))>=7
            lii=ASCAN(This.aKeys,0,1,-1,1,8)
         #ELSE
            lii=ASCAN(This.aKeys,0,1,-1)
            lii=IIF(lii=0,0,ASUBSCRIPT(This.aKeys,lii,1))
         #ENDIF   
         IF lii=0
            STORE This.iCount+1 TO This.iCount,lii
            DIMENSION This.aKeys(This.iCount,2)
         ENDIF
         loForm.LockScreenIndex=lii
         This.aKeys(lii,1)=1
         This.aKeys(lii,2)=loForm.LockScreen
         loForm.LockScreen=.T.
      ELSE
         This.aKeys(lii,1)=This.aKeys(lii,1)+1
      ENDIF
   ENDPROC

   PROCEDURE Pop(loForm)
      LOCAL lii
      IF NOT PEMSTATUS(loForm,"LockScreenIndex",5)
         ASSERT .F. MESSAGE _LSS_NotRegistered
         RETURN
      ENDIF

      lii=loForm.LockScreenIndex
      IF lii<=0
         ASSERT .F. MESSAGE _LSS_NotRegistered
         RETURN
      ENDIF      
      
      This.aKeys(lii,1)=This.aKeys(lii,1)-1
      IF This.aKeys(lii,1)=0
         loForm.LockScreenIndex=0
         loForm.LockScreen=This.aKeys(lii,2)
      ENDIF
   ENDPROC

ENDDEFINE